#ifndef _H_382EBD256D4E3150AEA19D4707FF82D2_AckermannDrive__H_
#define _H_382EBD256D4E3150AEA19D4707FF82D2_AckermannDrive__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace ackermann_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AckermannDrive_
            {
                ::DDS::Float steering_angle_;
                ::DDS::Float steering_angle_velocity_;
                ::DDS::Float speed_;
                ::DDS::Float acceleration_;
                ::DDS::Float jerk_;
            };

            typedef DDS_DCPSStruct_var<AckermannDrive_> AckermannDrive__var;
            typedef AckermannDrive_& AckermannDrive__out;

        }

    }

}

#endif /* _H_382EBD256D4E3150AEA19D4707FF82D2_AckermannDrive__H_ */
