// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ackermann_msgs:msg/AckermannDriveStamped.idl
// generated code does not contain a copyright notice
#include "ackermann_msgs/msg/ackermann_drive_stamped__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `drive`
#include "ackermann_msgs/msg/ackermann_drive__functions.h"

bool
ackermann_msgs__msg__AckermannDriveStamped__init(ackermann_msgs__msg__AckermannDriveStamped * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ackermann_msgs__msg__AckermannDriveStamped__fini(msg);
    return false;
  }
  // drive
  if (!ackermann_msgs__msg__AckermannDrive__init(&msg->drive)) {
    ackermann_msgs__msg__AckermannDriveStamped__fini(msg);
    return false;
  }
  return true;
}

void
ackermann_msgs__msg__AckermannDriveStamped__fini(ackermann_msgs__msg__AckermannDriveStamped * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // drive
  ackermann_msgs__msg__AckermannDrive__fini(&msg->drive);
}

ackermann_msgs__msg__AckermannDriveStamped *
ackermann_msgs__msg__AckermannDriveStamped__create()
{
  ackermann_msgs__msg__AckermannDriveStamped * msg = (ackermann_msgs__msg__AckermannDriveStamped *)malloc(sizeof(ackermann_msgs__msg__AckermannDriveStamped));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ackermann_msgs__msg__AckermannDriveStamped));
  bool success = ackermann_msgs__msg__AckermannDriveStamped__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ackermann_msgs__msg__AckermannDriveStamped__destroy(ackermann_msgs__msg__AckermannDriveStamped * msg)
{
  if (msg) {
    ackermann_msgs__msg__AckermannDriveStamped__fini(msg);
  }
  free(msg);
}


bool
ackermann_msgs__msg__AckermannDriveStamped__Sequence__init(ackermann_msgs__msg__AckermannDriveStamped__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ackermann_msgs__msg__AckermannDriveStamped * data = NULL;
  if (size) {
    data = (ackermann_msgs__msg__AckermannDriveStamped *)calloc(size, sizeof(ackermann_msgs__msg__AckermannDriveStamped));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ackermann_msgs__msg__AckermannDriveStamped__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ackermann_msgs__msg__AckermannDriveStamped__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ackermann_msgs__msg__AckermannDriveStamped__Sequence__fini(ackermann_msgs__msg__AckermannDriveStamped__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ackermann_msgs__msg__AckermannDriveStamped__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ackermann_msgs__msg__AckermannDriveStamped__Sequence *
ackermann_msgs__msg__AckermannDriveStamped__Sequence__create(size_t size)
{
  ackermann_msgs__msg__AckermannDriveStamped__Sequence * array = (ackermann_msgs__msg__AckermannDriveStamped__Sequence *)malloc(sizeof(ackermann_msgs__msg__AckermannDriveStamped__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ackermann_msgs__msg__AckermannDriveStamped__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ackermann_msgs__msg__AckermannDriveStamped__Sequence__destroy(ackermann_msgs__msg__AckermannDriveStamped__Sequence * array)
{
  if (array) {
    ackermann_msgs__msg__AckermannDriveStamped__Sequence__fini(array);
  }
  free(array);
}
