#ifndef _H_FA39E3C598CD31D3034F883F7B67B18E_AckermannDriveStamped_DCPS_H_
#define _H_FA39E3C598CD31D3034F883F7B67B18E_AckermannDriveStamped_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AckermannDriveStamped_.h"


namespace ackermann_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AckermannDriveStamped_TypeSupportInterface;

            typedef AckermannDriveStamped_TypeSupportInterface * AckermannDriveStamped_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AckermannDriveStamped_TypeSupportInterface> AckermannDriveStamped_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AckermannDriveStamped_TypeSupportInterface> AckermannDriveStamped_TypeSupportInterface_out;


            class AckermannDriveStamped_DataWriter;

            typedef AckermannDriveStamped_DataWriter * AckermannDriveStamped_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AckermannDriveStamped_DataWriter> AckermannDriveStamped_DataWriter_var;
            typedef DDS_DCPSInterface_out < AckermannDriveStamped_DataWriter> AckermannDriveStamped_DataWriter_out;


            class AckermannDriveStamped_DataReader;

            typedef AckermannDriveStamped_DataReader * AckermannDriveStamped_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AckermannDriveStamped_DataReader> AckermannDriveStamped_DataReader_var;
            typedef DDS_DCPSInterface_out < AckermannDriveStamped_DataReader> AckermannDriveStamped_DataReader_out;


            class AckermannDriveStamped_DataReaderView;

            typedef AckermannDriveStamped_DataReaderView * AckermannDriveStamped_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AckermannDriveStamped_DataReaderView> AckermannDriveStamped_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AckermannDriveStamped_DataReaderView> AckermannDriveStamped_DataReaderView_out;

            struct AckermannDriveStamped_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AckermannDriveStamped_, struct AckermannDriveStamped_Seq_uniq_> AckermannDriveStamped_Seq;
            typedef DDS_DCPSSequence_var < AckermannDriveStamped_Seq> AckermannDriveStamped_Seq_var;
            typedef DDS_DCPSSequence_out < AckermannDriveStamped_Seq> AckermannDriveStamped_Seq_out;

            class  AckermannDriveStamped_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AckermannDriveStamped_TypeSupportInterface_ptr _ptr_type;
                typedef AckermannDriveStamped_TypeSupportInterface_var _var_type;

                static AckermannDriveStamped_TypeSupportInterface_ptr _duplicate (AckermannDriveStamped_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDriveStamped_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDriveStamped_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AckermannDriveStamped_TypeSupportInterface () {};
                ~AckermannDriveStamped_TypeSupportInterface () {};
            private:
                AckermannDriveStamped_TypeSupportInterface (const AckermannDriveStamped_TypeSupportInterface &);
                AckermannDriveStamped_TypeSupportInterface & operator = (const AckermannDriveStamped_TypeSupportInterface &);
            };

            class  AckermannDriveStamped_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AckermannDriveStamped_DataWriter_ptr _ptr_type;
                typedef AckermannDriveStamped_DataWriter_var _var_type;

                static AckermannDriveStamped_DataWriter_ptr _duplicate (AckermannDriveStamped_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDriveStamped_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDriveStamped_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AckermannDriveStamped_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AckermannDriveStamped_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AckermannDriveStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AckermannDriveStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AckermannDriveStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AckermannDriveStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AckermannDriveStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AckermannDriveStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AckermannDriveStamped_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AckermannDriveStamped_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AckermannDriveStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AckermannDriveStamped_& instance_data) = 0;

            protected:
                AckermannDriveStamped_DataWriter () {};
                ~AckermannDriveStamped_DataWriter () {};
            private:
                AckermannDriveStamped_DataWriter (const AckermannDriveStamped_DataWriter &);
                AckermannDriveStamped_DataWriter & operator = (const AckermannDriveStamped_DataWriter &);
            };

            class  AckermannDriveStamped_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AckermannDriveStamped_DataReader_ptr _ptr_type;
                typedef AckermannDriveStamped_DataReader_var _var_type;

                static AckermannDriveStamped_DataReader_ptr _duplicate (AckermannDriveStamped_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDriveStamped_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDriveStamped_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AckermannDriveStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AckermannDriveStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AckermannDriveStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AckermannDriveStamped_& instance) = 0;

            protected:
                AckermannDriveStamped_DataReader () {};
                ~AckermannDriveStamped_DataReader () {};
            private:
                AckermannDriveStamped_DataReader (const AckermannDriveStamped_DataReader &);
                AckermannDriveStamped_DataReader & operator = (const AckermannDriveStamped_DataReader &);
            };

            class  AckermannDriveStamped_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AckermannDriveStamped_DataReaderView_ptr _ptr_type;
                typedef AckermannDriveStamped_DataReaderView_var _var_type;

                static AckermannDriveStamped_DataReaderView_ptr _duplicate (AckermannDriveStamped_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AckermannDriveStamped_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AckermannDriveStamped_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AckermannDriveStamped_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AckermannDriveStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AckermannDriveStamped_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AckermannDriveStamped_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AckermannDriveStamped_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AckermannDriveStamped_& instance) = 0;

            protected:
                AckermannDriveStamped_DataReaderView () {};
                ~AckermannDriveStamped_DataReaderView () {};
            private:
                AckermannDriveStamped_DataReaderView (const AckermannDriveStamped_DataReaderView &);
                AckermannDriveStamped_DataReaderView & operator = (const AckermannDriveStamped_DataReaderView &);
            };
        }

    }

}

#endif
